#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		long long i, j;
		long long n, m;
		cin >> n >> m;
		long long godineprihv[75001];
		long long godineodbijanja[75001];

		for (i = 0; i < n; i++)
		{
			cin >> godineprihv[i];
		}
		for (i = 0; i < m; i++)
		{
			cin >> godineodbijanja[i];
		}
		sort(godineprihv, godineprihv + n);

		long long mogucix = godineprihv[1] - godineprihv[0];
		long long proveri = godineprihv[0];
		bool resenje = true;
		bool zaustavi = false;
		for (i = 0; i < n; i++)
		{
			proveri += mogucix;
			for (j = 0; j < m; j++)
			{
				if (proveri == godineodbijanja[j])
				{
					resenje = false;
					zaustavi = true;
					break;
				}
			}
			if (zaustavi)
			{
				break;
			}
		}

		if (resenje)
		{
			cout << 1 << endl;
		}
		else
		{
			cout << 0 << endl;
		}

		
	}
	return 0;
}